// O8MHzU킩40MHz̃NbN𐶐邽߂̐ݒ
#pragma config FNOSC = PRIPLL   // M = OU
#pragma config POSCMOD = XT     // 唭U̕@@= OxUg
#pragma config FPLLIDIV = DIV_2 // PLL͕ = x1/2
#pragma config FPLLMUL = MUL_20 // PLL{ = x20
#pragma config FPLLODIV = DIV_2 // PLLo͕ = x1/2
#pragma config FPBDIV = DIV_1   // ӃW[NbN{ : x1/1
#pragma config FWDTEN = OFF     // WDTgȂ
#pragma config FSOSCEN = OFF    // SOSCgȂ 
#pragma config JTAGEN = OFF     // JTAGgȂ

#include <xc.h>
#include <p32xxxx.h>
#include <sys/attribs.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#define false 0
#define true 1

// Definitions for MMC/SDC command
#define CMD0    (0)    /* GO_IDLE_STATE */
#define CMD1    (1)    /* SEND_OP_COND */
#define CMD8    (8)    /* SEND_IF_COND */
#define CMD9    (9)    /* SEND_CSD */
#define CMD10    (10)    /* SEND_CID */
#define CMD12    (12)    /* STOP_TRANSMISSION */
#define CMD16    (16)    /* SET_BLOCKLEN */
#define CMD17    (17)    /* READ_SINGLE_BLOCK */
#define CMD18    (18)    /* READ_MULTIPLE_BLOCK */
#define CMD23    (23)    /* SET_BLOCK_COUNT */
#define CMD24    (24)    /* WRITE_BLOCK */
#define CMD25    (25)    /* WRITE_MULTIPLE_BLOCK */
#define CMD41    (41)    /* SEND_OP_COND (ACMD) */
#define CMD55    (55)    /* APP_CMD */
#define CMD58    (58)    /* READ_OCR */

typedef signed char s8;
typedef unsigned char u8;
typedef signed short s16;
typedef unsigned short u16;
typedef signed int s32;
typedef unsigned int u32;
typedef signed long long s64;
typedef unsigned long long u64;


#define SYS_FREQ (40000000L)
#define _XTAL_FREQ 8000000
#define sd_cs   LATBbits.LATB15
#define GREEN   LATBbits.LATB7   
#define RED     LATBbits.LATB8 
#define BZ      LATBbits.LATB10
#define SW      PORTBbits.RB9
#define SD_POW  LATBbits.LATB4

void delay_ms(u32 dat);
u8 spi1(u8 dat);
u8 wait_ready (void);
u8 out_cmd(u8 cmd, u32 addr);
u8 rd_dat ( u8 *buf, u16 cnt);
u8 wsd_dat ( u8 *buf, u16 cnt);
void init_SPI1(void);
u8 init_SD(void);
u8 rd_sector( u8 *buf, u32 sector);
u8 wr_sector( u8 *buf, u32 sector);
void init_Timer1();
u8 send_cmd ( u8 cmd,  u32 arg);
u8 xmit_datablock ( const u8 *buff, u8 token);
u8 disk_write ( u8 drv, u8 *buff, u32 sector, u8 count);
void beep(u16 t);
void sendString(const char *s, int slen);
void putU(u8 s);
void puts16(s16 s);
void init_UART1(void);
void send_PC(u8 *dat);
void send_ad(u16 b);
void init_AD(u8 ch);
u8 disk_read (u8 drv, u8 *buff, u32 sector, u8 count);
u8 rcvr_spi (void);
void rcvr_spi_m (u8 *dst);

const u32 wf_size = 512 * 60 * 60 * 4;  // 2oCgP

u8 sd_dat[512];         // SDCpoCgf[^(1ZN^)
u32 sd_dat32[128];      // SDCplongf[^(1ZN^)
s16 ad_dat[512];        // ADCpf[^obt@
s16 ad_df_dat[512];     // fWtBpf[^obt@
u8 f_GR = 0;            // Γ_ŗp
u16 f_BZ = 0;           // BZIItp
u16 count = 0;          // Timer2pJE^
u16 TimeOut;            // ^CAEgp
u16 ad_idx;             // ADpCfbNX
u32 sd_idx;             // SDpCfbNX
u32 wp_sector;          // ݋֎~ZN^(ewavt@C̐擪ZN^)
u32 ecg_idx;            // ECGIDX.datpϐ
u32 file_offset;        // t@C̃ZN^ItZbg
u32 ecg000;             // ECG000.wavpϐ
u32 ecg001;             // ECG001.wavpϐ
u32 num_sector;         // ZN^ԍ
u16 bank;               // ADCobt@2oN\
u32 dat_cnt;            // ۑf[^
u8  ret;                // ֐̖߂l, ėp
u8  f_wr;               // ݉\tO Tv1ZN^(256)ɂȂZbg
u8  f_sd;               // 0=,s, 1=SDJ[hL
u8  f_save;             // 0=SDɕۑȂ,SDJ[hɕۑ
u8  f_rcv;              // UARTMtO
u8  f_wfend;            // WaveFileݏItO
u8  str[16];            // ϐ
u8  rx_dat[16];         // UARTMf[^
u16 rx_idx;             // UARTMCfbNX
u16 Tpush;              // XCb`ꂽ
u8  f_SW;               // XCb`tO
u8  sd_type;            // SDC̃^Cv, ZN^AhXقȂ
u32 sd_bpb;             // BPBZN^
u32 max_sector;         // wavt@C̍őZN^
u32 cluster_size;       // NX^TCY
u32 RsvdSecCnt;         // \TCY
u32 FatSz32;            // FATTCY
u32 dir_sector;         // DIR̃ZN^ԍ
u16 Van1;               // Vbat/2
u16 Vvref;              // PICd
u16 frame_num;          // t[ԍ
float bpm;              // S
float t_bpm;            // S
float ad_max;           // őADϊl
u32 i;                  // ėp
u32 j = 0;              // ėp
u16 ad_idx;             // TvOADCfbNX
char asci8[8];
float sum;              // fWtBvZŎgp(Ϙal)
float h[512];           // fWtB̌W
u8 f_df = 1;            // fWtBI
u8 f_bpm;               // StO
u8 tmp_BZ;              // BZϐ

int main(void)
{
    ANSELB = 0x00;              // RB͑SăfW^  
    TRISB = 0;                  // RB͑Sďo
    TRISBbits.TRISB11 = 1;      // RB11 =  = SDI1
    TRISBbits.TRISB9 = 1;       // RB9 =  = ^NgSW
    CNPUB =0x800 + 0x200;       // RB9ARB11 vAbv
    BZ = 0;                     // BZ~
    SD_POW = 1;                 // SDCd OFF
    delay_ms( 100 );            // 0.1s҂
    SD_POW = 0;                 // SDCdON 
    delay_ms( 1000 );           // 1s҂
    ANSELA = 0x03;              // AN0,1ȊO̓fW^  
    TRISA = 0x03;               // AN0,1͓
//    REFOCON = 0x9000;
 
    RPB13R = 3;                 // RB13 = SDO1
    SDI1R = 3;                  // RB11 = SDI1
 
    RED = 0;                    // ԏ   
    GREEN = 0;                  // Ώ   

    init_SPI1();                // SPI1W[̏
    init_AD(0);                 // ADCW[̏
    init_UART1();               // UARTW[̏
  
    if (init_SD() == false)
    {                       // SDCs
        GREEN = 1;              // Γ_
        RED = 1;                // ԓ_
        f_sd = 0;               // SDCgps\
        beep(1000);             // 1SBZ
        delay_ms( 1000 );       // 1s҂
        while(1);               // ~
    }
    else
    {                       // SDC
        GREEN = 1;              // Γ_
        f_sd = 1;
        beep(100);              // 0.1sBZ
        GREEN = 0;              // Ώ
    }

    if (!rd_sector(sd_dat, 1))  // 1ZN^Ǎ
    {                       // sGZN^ANZX̓oCgP
        sd_type = 1;            // 2G
    }
    
    SPI1BRG = 10;               // SYSFREQ / 10 = 4MHz; SPICLK4MHz

    ret = rd_sector(sd_dat, 0); // 0ZN^Ǎ
    sd_bpb = ((u32)sd_dat[457]<<24) +((u32)sd_dat[456]<<16) +((u32)sd_dat[455]<<8) +(u32)sd_dat[454];   // BPB(BIOS Parameter Block)vZ

    rd_sector(sd_dat, sd_bpb);  // BPBZN^̓Ǎ
    cluster_size = sd_dat[13];  // NX^TCY擾
    RsvdSecCnt = ((u16)sd_dat[15]<<8) +(u16)sd_dat[14]; // \̈̃ZN^
    FatSz32 = ((u32)sd_dat[39]<<24) +((u32)sd_dat[38]<<16) +((u32)sd_dat[37]<<8) +(u32)sd_dat[36];  // Faẗ̃ZN^
    dir_sector = RsvdSecCnt + 2 * FatSz32;  // fBNgZN^̌vZ
    rd_sector(sd_dat, dir_sector + sd_bpb); // fBNg̎擾

    for (file_offset = 0; file_offset < 0xa0; file_offset = file_offset +0x20)  // ECG_IDX.dat
    {
         if (strncmp("ECG_IDX", &sd_dat[file_offset], 5)== 0) break;    // for𔲂
    }
    ecg_idx =  (((u16)sd_dat[file_offset + 0x1b]<<8) +(u16)sd_dat[file_offset + 0x1a] - 2) * cluster_size + dir_sector; // ECG_IDX.dat̐擪ZN^ԍ
    
    ecg000 =  (((u16)sd_dat[file_offset + 0x3b]<<8) +(u16)sd_dat[file_offset + 0x3a] - 2) * cluster_size + dir_sector;  // ECG000.wav̐擪ZN^ԍ
    ecg001 =  (((u16)sd_dat[file_offset + 0x5b]<<8) +(u16)sd_dat[file_offset + 0x5a] - 2) * cluster_size + dir_sector;  // ECG001.wav̐擪ZN^ԍ
    sd_dat32[0] = ecg000;   // ECG_IDX.dat̐擪ZN^ԍ
    sd_dat32[4] = ecg000;   // ECG000.wav̐擪ZN^ԍ
    sd_dat32[5] = ecg001;   // ECG001.wav̐擪ZN^ԍ
    for ( i= 0; i < 100; i++)
    {
        sd_dat32[(i + 6)] = ecg001 + (i + 1) * (ecg001 - ecg000);   // ECGnnn.wav̐擪ZN^ԍsd_dat32[6]ȍ~ɐݒ]
    }
    max_sector = ecg001 + (100 + 1) * (ecg001 - ecg000) - 1;
    
    rd_sector(sd_dat32, ecg_idx + sd_bpb);
    if (sd_dat32[3] == 0)           // ECG_IDX.datidxݒ肳ĂȂ̂Ȃ
    {
        sd_dat32[3] = 1;                        // CfbNX
        ret = wr_sector(sd_dat32, ecg_idx + sd_bpb);    // ECG_IDX.datɏ
    }  

    rd_sector(h, ecg_idx + (sd_dat32[1] << 2) + 1 + sd_bpb);        // wfWtBԍ̌Wh[0]-h[127]
    rd_sector(&h[128], ecg_idx  + (sd_dat32[1] << 2) + 2 + sd_bpb); // wfWtBԍ̌Wh[128]-h[254]

    wp_sector = sd_dat32[0];        // ݕs̃ZN^ԍݒÃZN^ȍ~ADf[^ۑ
    sd_idx = wp_sector;             // sd_idxɏݕs̃ZN^ԍݒ
    dat_cnt = 0;                    // wavt@Cɕۑf[^̃JEg
    GREEN = 0;                      // Ώ
    init_Timer1();                  // Timer1W[
    init_Timer2();                  // Timer2W[

    while(1)
    {
        if (f_SW == 1)              // XCb`ꂽ?
        {
            f_SW = 0;               // SWtONA
            if (Tpush <= 100)       // 10ms * 100 = 1s łȂȂf[^ۑJn
            {
                 if (!f_save)       // ۑtO?
                 {
                    f_save = 1;     // f[^ۑtOI
                    beep(50);       // 50msr[v
                 }
            }
            else if (Tpush >= 200)  // Ȃf[^ۑI
            {
                f_save = 0;         // f[^ۑtOIt
                rd_sector(sd_dat32, ecg_idx + sd_bpb);  // ECG_IDX擪ZN^Ǎ
                wp_sector = sd_dat32[0];        // ݋֎~ZN^ = ̃t@C̐擪ZN^
                sd_idx = wp_sector; // sd_idx͏݋֎~ZN^

                GREEN = 0;          // Ώ
            }
            Tpush = 0;              // ԃNA
            IEC0bits.T2IE = 1;      // ^C}[2̊荞݂
        }

        if ( f_wr == 1)             // ADTvf[^̐256?
        {
            f_wr = 0;               // tONA
            frame_num = (frame_num + 1) & 0x3fff;   // t[ԍ1
            if(f_save)              // SDCւ̕ۑtOH
            {
                if (f_sd)           //SDLǂ
                {
                    f_GR = !f_GR;   // Γ_
                    GREEN = f_GR;   //
                
                    if (sd_idx == wp_sector)    // ݋֎~ZN^Ȃ玟̃ZN^, f[^ZN^
                    {
                        sd_idx++;               // ̃ZN^
                        dat_cnt = 0;            // f[^NA
                        rd_sector(sd_dat32, ecg_idx + sd_bpb);  // ECG_IDX擪ZN^Ǎ
                        for ( i=4; i<100; i++)  // wavt@C̐擪ZN^ԍ
                        {
                            if(wp_sector < sd_dat32[i]) // ݋֎~̃ZN^ԍ傫Ύ̃t@C
                            {
                                wp_sector = sd_dat32[i];    // ݋֎~ZN^ԍ̐ݒ
                                sd_dat32[0] = wp_sector;    // ECG_IDX擪ZN^0ԒnɎ݋֎~ZN^ԍݒ
                                ret = wr_sector(sd_dat32, ecg_idx + sd_bpb); // ECG_IDX擪ZN^ɏ
                                break;
                            }
                        }
                    }

                    ret = wr_sector (&ad_dat[bank], sd_idx + sd_bpb);   // adf[^sd_idxZN^ɏ
                    sd_idx++;                                           // sd_idx̃ZN^

                    if (f_wfend)        // t@CGh?
                    {
                        f_wfend = 0;                            // t@CGhtONA
                        rd_sector(sd_dat32, ecg_idx + sd_bpb);  // ECG_IDX.dat̐擪ZN^Ǎ
                        sd_idx = sd_dat32[0];                   // ̃t@C̐擪ZN^ԍ
                    }
                }
            }
            
            if (f_rcv)
            {
                f_rcv = 0;          // UARTMtONA
                switch(rx_dat[0])   // PC̖߂rx_dat[0]
                {
                case 's':       // AD̕ϊʂPCɑM
                    send_ad(bank);          // bankԍ̃f[^512oCgPCM
                    putU(frame_num);        // t[ԍPCM
                    putU(frame_num >> 8);
                    putU((u16)bpm);         // SPCM
                    putU((u16)bpm >> 8);
                    break;

                case 'D':       // ΃ZN^̃f[^PCɑM
                    strncpy(str, rx_dat + 1, 9+2);  // ZN^ԍp擾  
                    str[8+2] = 0;                   // zI[
                    num_sector = strtol(str, NULL, 0);  // ZN^ԍ擾
                    rd_sector(sd_dat, num_sector);  // ΃ZN^̃f[^擾
                    send_PC(sd_dat);                // 512oCgPCɑM
                    break;   
                    
                case 'I':       // ECG_IDX.dat̐擪ZN^f[^PCM
                    rd_sector(sd_dat, ecg_idx + sd_bpb);    // ECG_IDX.dat̐擪ZN^f[^擾
                    send_PC(sd_dat);                        // 512oCgPCɑM
                    break;
                    
                case 'f':       // fWtBW̐ݒ
                    rd_sector(sd_dat32, ecg_idx + sd_bpb);          // ECG_IDX.dat̐擪ZN^Ǎ
                    sd_dat32[1] = rx_dat[1] & 7;                    // tB^ԍ0-5sd_dat32[1]
                    ret = wr_sector (sd_dat32, ecg_idx + sd_bpb);   // ECG_IDX.dat̐擪ZN^ɏ
                    rd_sector(h, ecg_idx + (sd_dat32[1] << 2) + 1 + sd_bpb);        // wtB^̌Wh[0]-h[127]擾
                    rd_sector(&h[128], ecg_idx  + (sd_dat32[1] << 2) + 2 + sd_bpb); // wtB^̌Wh[128]-h[254]擾   //h[128]-
                    break;
                    
                case 'B':       // drd擾
                    IEC0bits.T1IE = 0;          // ^C}[1̊荞݂s
                    init_AD(1);                 // AN1(Vbat/2)ɐݒ
                    AD1CON1bits.SAMP = 1;       // ADTvOJn
                    AD1CON1bits.SAMP = 0;       // ADTvOI           
                    while(!AD1CON1bits.DONE){}  // ADϊ҂
                    Van1 = ADC1BUF0;            // Van1AN1ADC
                    init_AD(0xe);               // ADCIVREF
                    AD1CON1bits.SAMP = 1;       // ADTvOJn
                    AD1CON1bits.SAMP = 0;       // ADTvOI           
                    while(!AD1CON1bits.DONE){}  // ADϊ҂
                    Vvref = ADC1BUF0;           // VvrefIVREFADC
                    init_AD(0);                 // AN0ɐݒ߂
                    putU(Van1);                 // Van1PCɑM
                    putU(Van1 >> 8);
                    putU(Vvref);                // VvrefPCɑM
                    putU(Vvref >> 8);
                    IEC0bits.T1IE = 1;          // ^C}[1̊荞݂
                    break;   
                    
                }
                if (rx_dat[0] == 'd')           // _E[ĥ͍߂f_wrɔ񓯊œ
                {
                    f_rcv = 1;                  // _E[hɃR}hn
                }
                else
                {
                    rx_dat[0] = 0;              // PCR}hNA
                }

            }
        }

        if (f_rcv)
        {
            if (rx_dat[0] == 'd')
            {
                f_df = 0;                       // ̂߂ɃfWtBIt
                strncpy(str, rx_dat + 1, 9+2);  // ZN^ԍ擾
                str[8+2] = 0;                   // I[
                num_sector = strtol(str, NULL, 0);  // ZN^ԍ擾
                rd_sector(sd_dat, num_sector + sd_bpb); // wZN^ԍ̃f[^Ǎ
                send_PC(sd_dat);                // 512oCgPCɑM
                f_rcv = 0;                      // MtONA
                rx_dat[0] = 0;                  // PC߂NA
            }
        }
    }
}

// Configure the Timer 1 interrupt handler 512HzŌĂяo
void __ISR(_TIMER_1_VECTOR, IPL4SRS) Timer1Handler(void)
{
    IFS0bits.T1IF = 0;              // 荞݃tOZbg

    AD1CON1bits.SAMP = 1;           // ADTvOJn
    AD1CON1bits.SAMP = 0;           // ADTvOI           
    while(!AD1CON1bits.DONE){}      // ADϊ҂
    ad_dat[ad_idx] = ADC1BUF0 << 4; // ADϊl16{

    if (f_df)                       // fWtBIȂ炱ŌvZ
    {
        sum = 0;
        for (i = 0; i < 255; i++)
        {
           sum = sum + h[i] * (float)ad_dat[(ad_idx - 255 + i) & 0x1ff];
        }
        ad_df_dat[ad_idx] = (s16)sum;   // vZʂad_df_datzɕۑ
        
        // ŠvZ
        if ( sum > ad_max && t_bpm > 100 )
        {
            ad_max = sum;
        }
        else
        {
            if ( ((ad_max - sum) > 5*16) && (ad_max > 500 ))
            {
                bpm = 60.0 * 512.0 / t_bpm;
                if (bpm >=120 && bpm <= 180)    // 120ȏ180ȉȂbpmtO1Abv, 3񑱂BZxݒ
                {
                    f_bpm++;
                    if (f_bpm >= 3 && f_BZ ==0)
                    {
                        if (bpm >= 150)
                        {                        
                            f_BZ = 0xaa;    // 10101010@1BZ,0BZ~A4BZ
                        }
                        else if (bpm >=140)
                        {                        
                            f_BZ = 0xa8;    // 10101000@1BZ,0BZ~A3BZ
                        }
                        else if (bpm >=130)
                        {                        
                            f_BZ = 0xa0;    // 10100000@1BZ,0BZ~A2BZ
                        }
                        else if (bpm >=120)
                        {                        
                            f_BZ = 0x80;    // 10000000@1BZ,0BZ~A1BZ
                        }
                    }
                }
                else 
                {
                    f_BZ=0;                 // BZ͒~
                    f_bpm = 0;              // StONA
                }
                t_bpm = 1;
                ad_max = 0;
            }
        }
        t_bpm++;
    }
            
    ad_idx++;                   // ADCfbNX1i߂
    
    if (dat_cnt >= wf_size)     // .wavt@CTCYz炱̃t@C͏I
    {
        if (ad_idx <= 0x100)    // ADۑoNݒ
        {
            bank = 0;
        }
        else
        {
            bank = 0x100;
        }
        f_wr = 1;               // ݃tOZbg
        f_wfend = 1;            // wavt@CGhZbg
        dat_cnt = 0;
        ad_idx = 0;
    }
    dat_cnt++;                  // TvOJE^1i߂


    if (ad_idx == 0x100)        // ADۑoNݒ 
    {
        bank = 0;
        f_wr = 1;
    }
    else if  (ad_idx == 0x200)
    {
        bank = 0x100;
        f_wr = 1;
        ad_idx = 0;
    }
}

// Configure the Timer 2 interrupt handler 10msŌĂ΂
void __ISR(_TIMER_2_VECTOR, IPL5SRS) Timer2Handler(void)
{
    IFS0bits.T2IF = 0;              // 荞݃tOZbg
    if (SW == 0)
    {
        Tpush++;
        if (Tpush > 200) beep(50);  // 2sȏ㉟ꂽ50msr[v
    }
    else
    {
        if (Tpush > 5)              // 50msȓ̓`^OƔ
        {
            f_SW = 1;               // 50msȏ㉟ꂽtO𗧂Ă
            IEC0bits.T2IE = 0;      // ^C}[2̊荞ݒ~
        }
        else
        {
            f_SW = 0;               // XCb`tONA
            Tpush = 0;              // XCb`ԃNA
        }
    }
    
    count++;                        // xp^C}(SA[Ŏgp)
    if(count >= 15)                 // 0.15so珈
    {
        count = 0;                  // x^C}NA
        if ( f_BZ & 0x80 )          // f_BZMSB1?
        {
            BZ = 1;                 // uU[I
        }
        else
        {
            BZ = 0;                 // uU[It
        }
        f_BZ = f_BZ << 1;           // f_BZ1Vtg, ̐ݒɐi
    }
}

void __ISR(_UART_1_VECTOR, IPL4AUTO) OnUartReceiving(void) 
{
    u16 i;
    IFS1bits.U1RXIF = 0;            // UART1MtÕZbg

    if(U1STAbits.URXDA == 0) return;    // obt@̏ԂȂ牽Ȃ
    rx_dat[rx_idx] = (char)U1RXREG; // Mf[^obt@̃f[^i[
    
    // sR[hM邩obt@ςɂȂ
    if(rx_dat[rx_idx] == '\n' || rx_idx > 30)
    {
        f_rcv = 1;                  // MtOZbg
        rx_idx = 0;                 // PC̖߂ɔ
    }
    else
    {
        rx_idx++;                   // PC̖ߎM
    }
}

void init_UART1(void)       // UART1W[̏
{
    TRISBbits.TRISB2 = 1;   // RB2 = UART1/RX

    U1RXR = 4;              // UART1/RX = RB2
    RPB3R = 1;              // RB3 = UART1/TX
    
    U1STAbits.UTXEN = 1;    // UART1̑ML
    U1STAbits.URXEN = 1;    // UART1̎ML
//    U1BRG = 259;          // {[[g9600 [40M/(16*9600)-1]
//    U1BRG = 21;           // {[[g115200 [40M/(16*115200)-1]
//    U1BRG = 9;            // {[[g256000 [40M/(16*256000)-1]
    U1BRG = 4;              // {[[g500000 [40M/(16*500000)-1]
    
    U1MODEbits.ON = 1;      // UART1L
    IPC8bits.U1IP = 4;      // UART1D抄荞ݓx
    IPC8bits.U1IS = 3;      // UART1Dx
    
    IFS1bits.U1RXIF = 0;    // UART1MtÕZbg
    IFS1bits.U1TXIF = 0;    // UART1MtÕZbg
    
    IEC1bits.U1RXIE = 1;    // UART1M荞݂L
    IEC1bits.U1TXIE = 0;    // UART1M荞݂𖳌
    
    INTCONbits.MVEC = 1;    // }`xN^荞݂Lɂ
       
    __builtin_enable_interrupts();  // }CRɂ銄荞݂̗L
}

void    send_PC(u8 *dat)    // PC512oCgf[^M
{
    u16 i;
    for (i=0 ; i<512; i++)
    {
        putU(dat[i]);       // PC1oCgf[^M
    }
    
}

void    send_ad(u16 b)     // PC256*2Tvf[^M
{
    u16 i;
    for (i=0 ; i<256; i++)
    {
        puts16(ad_dat[i + b]);      // ADCf[^
        puts16(ad_df_dat[i + b]);   // fWtBf[^
    }
    
}

void sendString(const char *s, int slen)    // PCɑM
{
    u16 i;
    for(i = 0; i < slen; i++)
    {
        putU(s[i]);
    }
}

void putU(u8 s)
{
    U1TXREG = s;                // Mf[^U1TXREGɐݒ
    while(U1STAbits.UTXBF) ;    // obt@ɋ󂫂o܂őҋ@
}

void puts16(s16 s)              // 2oCgM
{
    U1TXREG = s;                // ʃoCgU1TXREGɐݒ
    while(U1STAbits.UTXBF) ;    // obt@ɋ󂫂o܂őҋ@
    U1TXREG = (u16)s >> 8;      // ʃoCgU1TXREGɐݒ
    while(U1STAbits.UTXBF) ;    // obt@ɋ󂫂o܂őҋ@
}

void    init_AD(u8 ch)          // ADCW[̏
{
    AD1CON1bits.ON = 0;         // ADCW[OFF
    AD1CON1bits.FORM = 1;       // f[^͕t16bit
    AD1CON3bits.ADCS = 2;       // ADCLK 1/8
    AD1CHSbits.CH0SA = ch;      // IN+ = ch
    AD1CON1bits.ON = 1;         // ADCW[ON
    delay_ms( 10 );
}

void init_SPI1(void)            // SPI1W[
{
    SPI1CONbits.ON = 0;         // SPI1W[~
    
    SPI1BRG = 100;              // SYSFREQ / 100 = 400kHz
    SPI1CONbits.MSTEN = 1;      // SPI1̓}X^[
    SPI1CONbits.CKP = 0;        // Mode0
    SPI1CONbits.CKE = 1;        // Mode0
    SPI1CONbits.ON = 1;         // SPI1W[
}

u8 spi1(u8 dat)
{
    SPI1BUF = dat;                  // ]f[^SPI1BUFɐݒ
    while(SPI1STATbits.SPIBUSY) ;   // ]܂ő҂
    return SPI1BUF;
}

void init_Timer1()
{
    T1CONbits.ON = 0;    // ݒ̂߁A^C}[1𖳌ɂ
    TMR1 = 0;            // ^C}[1Zbg
     
    // 0.36msŊ荞 <- 25ns(1 / 40MHz) * 1 * 14512(0x38b0) = 0.3628ms(11025kHz/4)
    T1CONbits.TCKPS = 0; // vXP[ : x1/1
    T1CONbits.TCKPS = 1; // vXP[ : x1/8
    PR1 = 0x38b0;        // JE^[
    PR1 = 0x4c4b / 2;        // 256Hz
//    PR1 = 0x8000;        // JE^[
//    PR1 = 0xe2c;        // JE^[
    
    INTCONbits.MVEC = 1; // }`xN^荞݂Lɂ
    
    IPC1bits.T1IP = 4;   // 荞ݗDx(0-7)
    IPC1bits.T1IS = 3;   // Dx(0-3)
    IFS0bits.T1IF = 0;   // 荞݃tOZbg
    IEC0bits.T1IE = 1;   // ^C}[1̊荞݂
    
    __builtin_enable_interrupts();  // }CRɂ銄荞݂̗LB
    T1CONbits.ON = 1;    // ^C}[1L
}

void init_Timer2()
{
    T2CONbits.ON = 0;    // ݒ̂߁A^C}[2𖳌ɂ
    TMR2 = 0;            // ^C}[2Zbg
     
    // 10msŊ荞 <- 25ns(1 / 40MHz) * 64 * 6250(0x186a) = 10ms
    T2CONbits.TCKPS = 6; // vXP[ : x1/64
    PR2 = 0x186a;        // JE^[
    
    INTCONbits.MVEC = 1; // }`xN^荞݂Lɂ
    
    IPC2bits.T2IP = 5;   // 荞ݗDx(0-7)
    IPC2bits.T2IS = 3;   // Dx(0-3)
    IFS0bits.T2IF = 0;   // 荞݃tOZbg
    IEC0bits.T2IE = 1;   // ^C}[2̊荞݂
    
    __builtin_enable_interrupts();  // }CRɂ銄荞݂̗LB
    T2CONbits.ON = 1;    // ^C}[2L
}

// FatFS痬p(ꕔύX)
u8 init_SD(void)
{
    u8 i, ret;
  
    for (i = 0; i < 20; i++)		//
    {
        ret = spi1(0xff);
    }
    delay_ms( 10 );

    sd_cs = 0;
    delay_ms( 10 );
    if (send_cmd(CMD0, 0x00) != 0x1)
    {
        delay_ms( 10 );
        {
            return false;
        }
    }
    ret = send_cmd(CMD8, 0x1aa);
    ret = spi1(0xff);
    ret = spi1(0xff);
    ret = spi1(0xff);
    ret = spi1(0xff);

    delay_ms( 2 );

    TimeOut = 500;           // ^CAEg500*2ms = 1s
    do {
        if (send_cmd(CMD55, 0) <= 1 && send_cmd(CMD41, 1UL << 30) == 0)    break;    /* ACMD41 with HCS bit */
        delay_ms( 2 );
       } while (--TimeOut);
 
    sd_cs = 1;
    if (TimeOut) return true;
    return false;
}

void    beep(u16 t)
{
    BZ = 1;
    delay_ms(t);
    BZ = 0;
}

void delay_ms(u32 dat)             // ???????????????????
{
  unsigned short j;
  unsigned long i;

  i = 3478L * (u32)dat;                  // ACLK(32.768kHz)????????????
                                          // 22??????(MCLK??????)
  do
  {
    i--;                                  // i?????????
  }while (i != 0);                        // i=0(??????)??????
}


// ------------ ȉFatFS痬p(ꕔύX) -----------
/*-----------------------------------------------------------------------*/
/* Receive a data packet from MMC                                        */
/*-----------------------------------------------------------------------*/

u8 rd_dat (
    u8 *buf,            /* Data buffer to store received data */
    u16 cnt            /* Byte count (must be even number) */
)
{
    u8 token;
    u16 i;

    TimeOut = 1000;
    do {                            /* Wait for data packet in timeout of 100ms */
        token = spi1(0xff);
        TimeOut--;
    } while ((token == 0xFF) && TimeOut);
//    } while ((token == 0xFF));
    if(token != 0xFE) return false;    // If not valid data token, retutn with error

  for (i = 0; i < cnt; i++)		//
  {
    buf[i] = spi1(0xff);
  }
   i = spi1(0xff);                        /* Discard CRC */
   i = spi1(0xff);

    return true;                    /* Return with success */
}


// FatFS痬p(ꕔύX)
u8 wsd_dat (
    u8 *buf,            /* Data buffer to store received data */
    u16 cnt            /* Byte count (must be even number) */
)
{
    u8 token, dummy;
    u16 i;

//    Timer1 = 100;
    do {                            /* Wait for data packet in timeout of 100ms */
        token = spi1(0xff);
    } while ((token == 0xFF));
    if(token != 0xFE) return false;    // If not valid data token, retutn with error
       delay_ms( 1 );

  for (i = 0; i < cnt; i++)		//
  {
    dummy = spi1(buf[i]);
  }
   i = spi1(0xff);                        /* Discard CRC */
   i = spi1(0xff);
        token = spi1(0xff);

    return true;                    /* Return with success */
}

/*-----------------------------------------------------------------------*/
/* Read Sector(s)                                                        */
/*-----------------------------------------------------------------------*/
u8 rd_sector(
    u8 *buf,            // Pointer to the data buffer to store read data
    u32 sector        // Start sector number (LBA)
)
{
//    if (!(CardType & 4)) sector *= 512;    /* Convert to byte addrets if needed */
    u8 ret;
    sd_cs = 0;

    if (sd_type) { sector = sector<<9; }
    ret = send_cmd(CMD17, sector);    // READ_SINGLE_BLOCK
    ret = rd_dat(buf, 512);
    
    sd_cs = 1;
//    rcvr_spi();            /* Idle (Release DO) */

    return ret;
}

// FatFS痬p(ꕔύX)
//--------------------------------------------------------------------
// Write Sector                                                        
//--------------------------------------------------------------------

u8 wr_sector(
    u8 *buf,            // Pointer to the write data
    u32 sector        // Start sector number (LBA)
)
{
//    if (drv || !count) return RES_PARERR;
//    if (Stat & STA_NOINIT) return RES_NOTRDY;
//    if (Stat & STA_PROTECT) return RES_WRPRT;

//    if (!(CardType & 4)) sector *= 512;    /* Convert to byte addrets if needed */

    if (sector < (ecg_idx + sd_bpb)) { RED = 1; GREEN = 0; while(1);}
//a    if (sector > (max_sector + sd_bpb)) { RED = 1; GREEN = 1; while(1);}
    
    if (sd_type) { sector = sector<<9; }
    sd_cs = 0; //SELECT();            /* CS = L */

        // Single block write
//    ret = send_cmd(CMD24, sector);
    ret = send_cmd(CMD24, sector);
    delay_ms(1);
    ret = xmit_datablock(buf, 0xFE);
    if (!ret) {beep(20);while(1);}
    sd_cs = 1; //DESELECT();            /* CS = H */
    spi1(0xff);            /* Idle (Release DO) */

    return ret;
}

void xmit_spi(u8 dat)
{
u8 dum;
SPI1BUF = dat;
    while(SPI1STATbits.SPIBUSY) ; // ???????????
    dum =  SPI1BUF;
}

u8 wait_ready (void)
{
    u8 ret;
    u16 Timer2;

    Timer2 = 5000;    /* Wait for ready in timeout of 500ms */
    spi1(0xff);
    do
        ret = spi1(0xff);
    while ((ret != 0xff) && Timer2);

    return ret;
}

// FatFS痬p(ꕔύX)
u8 send_cmd (
    u8 cmd,        /* Command byte */
    u32 arg        /* Argument */
)
{
    u8 n, ret;


    if (wait_ready() != 0xFF) return 0xFF;

    /* Send command packet */
    xmit_spi(cmd | 0x40);                        /* Command */
    xmit_spi((u8)(arg >> 24));        /* Argument[31..24] */
    xmit_spi((u8)(arg >> 16));        /* Argument[23..16] */
    xmit_spi((u8)(arg >> 8));            /* Argument[15..8] */
    xmit_spi((u8)arg);                /* Argument[7..0] */
    n = 0xff;
    if (cmd == CMD0) n = 0x95;            /* CRC for CMD0(0) */
    if (cmd == CMD8) n = 0x87;            /* CRC for CMD8(0x1AA) */
    xmit_spi(n);

    /* Receive command retponse */
    if (cmd == CMD12) rcvr_spi();        /* Skip a stuff byte when stop reading */
    n = 10;                                /* Wait for a valid retponse in timeout of 10 attempts */
    do
        ret = rcvr_spi();
    while ((ret & 0x80) && --n);

    return ret;            /* Return with the retponse value */
}


// FatFS痬p(ꕔύX)
u8 xmit_datablock (
    const u8 *buff,    /* 512 byte data block to be transmitted */
    u8 token            /* Data/Stop token */
)
{
    u8 retp, wc;


    if (wait_ready() != 0xff) return false;

    spi1(token);                    /* Xmit data token */
    if (token != 0xFD) {    /* Is data token */
        wc = 0;
        do {                            /* Xmit the 512 byte data block to MMC */
            spi1(*buff++);
            spi1(*buff++);
        } while (--wc);
        spi1(0xFF);                    /* CRC (Dummy) */
        spi1(0xFF);
        retp = spi1(0xff);                /* Reveive data retponse */
        if ((retp & 0x1F) != 0x05)        /* If not accepted, return with error */
            return false;
    }

    return true;
}

// FatFS痬p(ꕔύX)
static
u8 send_cmd12 (void)
{
    u8 n, ret, val;

    /* For CMD12, we don't wait for the card to be idle before we send
     * the new command.
     */

    /* Send command packet - the argument for CMD12 is ignored. */
    spi1(0x40 | CMD12);
    spi1(0);
    spi1(0);
    spi1(0);
    spi1(0);
    spi1(0);

    /* Read up to 10 bytes from the card, remembering the value read if it's
       not 0xFF */
    for(n = 0; n < 10; n++)
    {
        val = rcvr_spi();
        if(val != 0xFF)
        {
            ret = val;
        }
    }

    return ret;            /* Return with the retponse value */
}

// FatFS痬p(ꕔύX)
/*-----------------------------------------------------------------------*/
/* Receive a byte from MMC via SPI  (Platform dependent)                 */
/*-----------------------------------------------------------------------*/

u8 rcvr_spi (void)
{
    SPI1BUF = 0xff;
    while(SPI1STATbits.SPIBUSY) ; // ???????????
    return SPI1BUF;
}


// FatFS痬p(ꕔύX)
void rcvr_spi_m (u8 *dst)
{
    *dst = rcvr_spi();
}



// FatFS痬p(ꕔύX)
/*-----------------------------------------------------------------------*/
/* Receive a data packet from MMC                                        */
/*-----------------------------------------------------------------------*/

static
u8 rcvr_datablock (
    u8 *buff,            /* Data buffer to store received data */
    u16 btr            /* Byte count (must be even number) */
)
{
    u8 token;
    u16 Timer1;

    Timer1 = 100;
    do {                            /* Wait for data packet in timeout of 100ms */
        token = rcvr_spi();
    } while ((token == 0xFF) && Timer1);
    if(token != 0xFE) return false;    /* If not valid data token, retutn with error */

    do {                            /* Receive the data block into buffer */
        rcvr_spi_m(buff++);
        rcvr_spi_m(buff++);
    } while (btr -= 2);
    rcvr_spi();                        /* Discard CRC */
    rcvr_spi();

    return true;                    /* Return with success */
}

// FatFS痬p(ꕔύX)
/*-----------------------------------------------------------------------*/
/* Read Sector(s)                                                        */
/*-----------------------------------------------------------------------*/

u8 disk_read (
    u8 drv,            /* Physical drive nmuber (0) */
    u8 *buff,            /* Pointer to the data buffer to store read data */
    u32 sector,        /* Start sector number (LBA) */
    u8 count            /* Sector count (1..255) */
)
{
//    if (drv || !count) return RES_PARERR;
//    if (Stat & STA_NOINIT) return RES_NOTRDY;

//    if (!(CardType & 4)) sector *= 512;    /* Convert to byte addrets if needed */

    sd_cs = 0; //SELECT();            /* CS = L */

//    ret  = send_cmd(CMD18, sector);
    ret  = send_cmd(CMD17, sector);
    ret = rcvr_datablock(buff, 512);
//    ret  = send_cmd(CMD12, sector);

    rcvr_spi();            /* Idle (Release DO) */
    sd_cs = 1;    //DESELECT();            /* CS = H */

    return count;
}


// FatFS痬p(ꕔύX)
u8 disk__write (
    u8 drv,            /* Physical drive nmuber (0) */
    u8 *buff,    /* Pointer to the data to be written */
    u32 sector,        /* Start sector number (LBA) */
    u8 count            /* Sector count (1..255) */
)
{
//    if (drv || !count) return RES_PARERR;
//    if (Stat & STA_NOINIT) return RES_NOTRDY;
//    if (Stat & STA_PROTECT) return RES_WRPRT;

//    if (!(CardType & 4)) sector *= 512;    /* Convert to byte addrets if needed */

    if (sd_type) { sector = sector<<9; }
    sd_cs = 0; //SELECT();            /* CS = L */

    if (count == 1) {    /* Single block write */
        if ((send_cmd(CMD24, sector) == 0)    /* WRITE_BLOCK */
            && xmit_datablock(buff, 0xFE))
            count = 0;
    }
    sd_cs = 1; //DESELECT();            /* CS = H */
    spi1(0xff);            /* Idle (Release DO) */

    return count;
}

